package view
{
	import com.greensock.TweenLite;
	import events.CardEvent;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.ui.Keyboard;
	import flash.utils.setTimeout;
	import manager.GameManager;
	import me.rainssong.display.DisplayCore;
	import me.rainssong.events.GameEvent;
	import me.rainui.RainUI;
	import me.rainui.components.Button;
	import me.rainui.components.Container;
	import me.rainui.components.Label;
	import me.rainui.components.Page;
	import me.rainui.events.RainUIEvent;
	import view.card.Card;
	import view.card.skillCard.LookCard;
	
	/**
	 * @date 2016/12/10 15:05
	 * @author rainssong
	 * @blog http://blog.sina.com.cn/rainssong
	 * @homepage http://www.rainssong.com
	 * @weibo http://www.weibo.com/rainssong
	 */
	public class GameScene extends Page
	{
		
		public var addBtn:Button
		public var room:Room;
		public var discardPile:CardGroup
		
		public var human:HumanPlayer
		
		public var ageLabel:Label
		
		
		public var life:LifePlayer
		
		private var _round:int = 0;
		
		public var humanTurn:Boolean = true;
		
		public function GameScene(dataSource:Object = null)
		{
			super(dataSource);
			
			RainUI.stage.addEventListener(KeyboardEvent.KEY_DOWN, onKey);
		}
		
		private function onKey(e:KeyboardEvent):void
		{
			switch (e.keyCode)
			{
				case Keyboard.K: 
					round += 2;
					break;
				default: 
			}
		}
		
		override protected function createChildren():void
		{
			addChild(room = new Room());
			
			human = new HumanPlayer();
			life = new LifePlayer()
			
			human.opponent = life;
			life.opponent = human;
			
			human.addEventListener(CardEvent.PLAY_CARD, onPlayCard);
			human.addEventListener(CardEvent.PLAY_CARD_COMPLETE, onPlayComplete);
			life.addEventListener(CardEvent.PLAY_CARD, onPlayCard);
			life.addEventListener(CardEvent.PLAY_CARD_COMPLETE, onPlayComplete);
			
			discardPile = new CardGroup();
			addChild(discardPile);
			discardPile.width = 1136;
			discardPile.minGap =discardPile.maxGap= 4;
			discardPile.centerY = 0;
			discardPile.height = 200;
			
			addChild(human.handCards);
			human.handCards.percentWidth = 1
			human.handCards.bottom = 20;
			
			addChild(life.handCards);
			life.handCards.y =-200;
			
			addChild(human.pileCards);
			human.pileCards.y = 640;
			human.pileCards.percentWidth = 1
			
			ageLabel = new Label("0");
			addChild(ageLabel);
			
			super.createChildren();
		}
		
		private function onPlayCard(e:CardEvent):void 
		{
			humanTurn = !humanTurn;
		}
		
		private function onPlayComplete(e:CardEvent):void 
		{
			next();
		}
		
		override protected function initialize():void
		{
			super.initialize();
			GameManager.gameScene = this;
			start();
		}
		
		public function start():void
		{
			restart();
		}
		
		public function restart():void 
		{
			round = 0;
			humanTurn = true;
			TweenLite.to(room.bgSkin, 1.5, { alpha:1 } );
			human.reset();
			life.reset();
			discardPile.removeAllCards();
			
			human.pileCards.addCard(new LookCard);
			setTimeout(human.drawCards, 400);
		}
		
		public function next():void
		{
			if (!humanTurn)
			{
				life.action();//事件附带抽卡
				round++;
				human.handCards.newRound();
				
			}
			else
			{
				human.drawCards();
			}
		}
		
		public function get round():int 
		{
			return _round;
		}
		
		public function set round(value:int):void 
		{
			_round = value;
			ageLabel.text = round.toString();
		}
		

		

	
	}

}