package view
{
	import events.CardEvent;
	import flash.events.EventDispatcher;
	import flash.utils.setTimeout;
	import manager.GameManager;
	import view.card.Card;
	
	/**
	 * @date 2016/12/10 20:33
	 * @author rainssong
	 * @blog http://blog.sina.com.cn/rainssong
	 * @homepage http://www.rainssong.com
	 * @weibo http://www.weibo.com/rainssong
	 */
	public class Player extends EventDispatcher
	{
		public var handCards:CardGroup
		//public var gameScene:GameScene
		public var opponent:Player
		
		public var pileCards:CardGroup;
		
		public function Player()
		{
			handCards = new CardGroup();
			handCards.owner = this;
			
			pileCards = new CardGroup();
			pileCards.owner = this;
		}
		
		public function drawCard():void
		{
			handCards.addCard(pileCards.shift());
		}
		
		public function drawCards():void
		{
			while (pileCards.length > 0)
			{
				handCards.addCard(pileCards.shift());
			}
		}
		
		public function playCard(card:Card):void
		{
			handCards.draw(card);
			gameScene.discardPile.addCard(card);
			this.dispatchEvent(new CardEvent(CardEvent.PLAY_CARD));
			setTimeout(onPlayActive, 1000, card);
			setTimeout(onPlayComplete, 2000, card);
		}
		
		public function discard(card:Card):void
		{
			//handCards.draw(card);
			//gameScene.discardPile.addCard(card);
			
			handCards.removeCard(card);
			this.dispatchEvent(new CardEvent(CardEvent.DISCARD));
		}
		
		public function discardClass(cls:Class):void
		{
			for (var i:int = 0; i < handCards.length; i++)
			{
				if (handCards.getCard(i) as cls)
					discard(handCards.getCard(i));
				
			}
			
			for (i = 0; i < pileCards.length; i++)
			{
				if (pileCards.getCard(i) as cls)
					pileCards.removeCard(pileCards.getCard(i));
			}
		
		}
		
		public function discardAllCard():void
		{
			while (handCards.length)
			{
				discard(handCards.getCard(0));
			}
		}
		
		public function hasCard(cls:Class):Boolean
		{
			//var result:Boolean = false;
			for (var i:int = 0; i < handCards.length; i++)
			{
				if (handCards.getCard(i) as cls)
					return true
			}
			return false;
		}
		
		public function onPlayActive(card:Card):void
		{
			card.active();
		}
		
		public function onPlayComplete(card:Card):void
		{
			this.dispatchEvent(new CardEvent(CardEvent.PLAY_CARD_COMPLETE));
		}
		
		public function get gameScene():GameScene
		{
			return GameManager.gameScene;
		}
		
		public function reset():void
		{
			handCards.removeAllCards();
			pileCards.removeAllCards();
		}
	
	}

}