package view.card 
{
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.GameInputEvent;
	import flash.utils.describeType;
	import manager.GameManager;
	import me.rainssong.utils.Align;
	import me.rainssong.utils.ObjectCore;
	import me.rainssong.utils.ScaleMode;
	import me.rainui.components.Container;
	import me.rainui.components.Image;
	import me.rainui.components.Label;
	import view.CardGroup;
	import view.GameScene;
	import view.HumanPlayer;
	import view.LifePlayer;
	import view.Player;
	
	
	/**
	 * @date 2016/12/10 13:00
	 * @author rainssong
	 * @blog http://blog.sina.com.cn/rainssong
	 * @homepage http://www.rainssong.com
	 * @weibo http://www.weibo.com/rainssong
	 */
	public dynamic class Card extends Container 
	{
		
		public static const CardHeight:Number = 160;
		public static const CardWidth:Number = 120;
		
		static public const EVENT_CARD:String = "eventCard";
		static public const CHARACTER_CARD:String = "characterCard";
		static public const SKILL_CARD:String = "skillCard";
		
		private var _cardName:String;
		private var _type:String;
		private var _skin:Image 
		private var _label:Label
		private var _group:CardGroup
		
		public var owner:Player;
		
		public function Card(cardName:String="default") 
		{
			super();
			
			name = cardName;
			
			destroyOnRemove = false;
		}
		
		override protected function createChildren():void 
		{
			var sp:Shape = new Shape();
			sp.graphics.beginFill(0, 0);
			sp.graphics.drawRect(0, 0, CardWidth, CardHeight);
			addChild(sp);
			
			_skin = new Image();
			addChild(_skin);
			_skin.contentScaleMode=ScaleMode.FULL_FILL
			this.width=_skin.width = CardWidth;
			this.height=_skin.height = CardHeight;
			
			_label = new Label("12121" );
			_label.align = Align.CENTER;
			_label.multiline = true;
			_label.centerX = _label.centerY = 0;
			_label.size = 20;
			_label.width = CardWidth-10;
			//_label.autoSize = true;
			_label.wordWrap = true;
			_skin.addChild(_label);
			
			
			
			super.createChildren();
			
			this.mouseChildren = false;
		}
		
		override public function get name():String 
		{
			return _cardName;
		}
		
		override public function set name(value:String):void 
		{
			_cardName = value;
			_label.text = value;
			_skin.url = "assets/card/Default.png";
		}
		
		public function get describe():String 
		{
			return _label.text;
		}
		
		public function set describe(value:String):void 
		{
			_label.text = value;
		}
		
		
		public function play():void
		{
			
		}
		
		public function active():void
		{
			
		}
		
		public function get gameScene():GameScene
		{
			return GameManager.gameScene;
		}
		
		public function get group():CardGroup 
		{
			return _group;
		}
		
		public function set group(value:CardGroup):void 
		{
			if (value == _group)
			return;
			
			_group = value;
		}
		
		public function clone():Card
		{
			
			var card:Card = new (this as Object).constructor();
			
			card.group = _group;
			card.owner = owner;
			
			return card;
		}
		
		public function update():void
		{
			
		}
		
		public function get human():HumanPlayer
		{
			return GameManager.gameScene.human;
		}
		
		public function get lifePlayer():LifePlayer
		{
			return GameManager.gameScene.life;
		}
		
		public function get skin():Image 
		{
			return _skin;
		}
	}

}